library character_ellipsis_text;

import 'package:flutter/widgets.dart';

class CharEllipsisText extends StatefulWidget {
  CharEllipsisText(this.text, this.textStyle);

  final String text;
  final TextStyle textStyle;

  @override
  _CharEllipsisTextState createState() => _CharEllipsisTextState();
}

class _CharEllipsisTextState extends State<CharEllipsisText> {

  @override
  Widget build(BuildContext context) {
    return LayoutBuilder(builder: (context, size) {
      var span = TextSpan(
        style: widget.textStyle,
        text: widget.text,
      );

      int textLength = widget.text.length;
      if (!_checkTextFits(span, 1, size)) {
        int loopLength = widget.text.length;

        while (loopLength > 0) {
          loopLength = loopLength~/2;
          if (!_checkTextFits(span, 1, size)) {
            textLength -= loopLength;
          } else {
            textLength += loopLength;
          }
          var textList = widget.text.split("");
          textList = textList.sublist(0, textLength);

          span = TextSpan(
            style: widget.textStyle,
            text: textList.join(),
          );
        }
        var textList = widget.text.split("");
        textList = textList.sublist(0, textLength-3);
        return Text(textList.join() + '...', style: widget.textStyle, maxLines: 1, softWrap: true, overflow: TextOverflow.ellipsis,);
      } else {
        return Text(widget.text, style: widget.textStyle, maxLines: 1, softWrap: true, overflow: TextOverflow.ellipsis,);
      }

    });
  }

  bool _checkTextFits(
      TextSpan text, int maxLines, BoxConstraints constraints) {
    var tp = TextPainter(
      text: text,
      textAlign: TextAlign.left,
      textDirection: TextDirection.ltr,
      textScaleFactor: 1,
      maxLines: maxLines,
    );
    tp.layout(maxWidth: constraints.maxWidth);
    return !(tp.didExceedMaxLines ||
        tp.height > constraints.maxHeight ||
        tp.width > constraints.maxWidth);
  }
}